*-------------------------------------------------------------------------*
 |                                                                         
 |                    SAS SETUP FILE FOR ICPSR 09735
 |        CRIMINAL CAREERS AND CRIME CONTROL IN MASSACHUSETTS [THE
 |         GLUECK STUDY]: A MATCHED-SAMPLE LONGITUDINAL RESEARCH
 |                       DESIGN, PHASE I, 1939-1963
 |                       (DATASET 0001:  DATA FILE)
 |
 |
 | SAS setup sections are provided for the ASCII version of this data
 | collection.  These sections are listed below:
 |
 | PROC FORMAT:  creates user-defined formats for the variables. Formats
 | replace original value codes with value code descriptions. Only
 | variables with user-defined formats are included in this section.
 |
 | DATA:  begins a SAS data step and names an output SAS data set.
 |
 | INFILE:  identifies the input file to be read with the input statement.
 | Users must replace the "data-filename" with a filename specifying the
 | directory on the user's computer system in which the downloaded and
 | unzipped data file is physically located (e.g.,
 | "c:\temp\09735-0001Q-data.txt").
 |
 | INPUT:  assigns the name, type, decimal specification (if any), and
 | specifies the beginning and ending column locations for each variable
 | in the data file.
 |
 | LABEL:  assigns descriptive labels to all variables. Variable labels
 | and variable names may be identical for some variables.
 |
 | MISSING VALUE RECODES:  sets user-defined numeric missing values to
 | missing as interpreted by the SAS system. Only variables with
 | user-defined missing values are included in this section.
 |
 | FORMAT:  associates the formats created by the PROC FORMAT step with
 | the variables named in the INPUT statement.
 |
 | NOTE:  Users should modify this setup file to suit their specific needs.
 | Sections for PROC FORMAT, FORMAT, and MISSING VALUE RECODES have been
 | commented out (i.e., '/*'). To include these sections in the final SAS
 | setup, users should remove the SAS comment indicators from the desired
 | section(s).
 |
 *------------------------------------------------------------------------;

* SAS PROC FORMAT;

/*
PROC FORMAT;
  VALUE V3ffffff  99='(99) blanked' ;
  VALUE V4ffffff  99='(99) blanked' ;
  VALUE V9ffffff  88='(88) not applicable' ;
  VALUE V10fffff  88='(88) not applicable' ;
  VALUE V11fffff  88='(88) not applicable' ;
  VALUE V12fffff  88='(88) not applicable' ;
  VALUE V13fffff  88='(88) not applicable' ;
  VALUE V14fffff  88='(88) not applicable' ;
  VALUE V15fffff  99='(99) blanked' ;
  VALUE V16fffff  99='(99) blanked' ;
  VALUE V17fffff  88='(88) not applicable' ;
  VALUE V18fffff  1='(1) Lyman (L.S.)' 2='(2) Shirley (I.S.B.)' 3='(3) other delinquent' ;
  VALUE V20fffff  1='(1) coder 1' 2='(2) coder 2' 3='(3) coder 3' 4='(4) coder 4' ;
  VALUE V22fffff  1='(1) time 1' 2='(2) time 2' 3='(3) time 3' ;
  VALUE V24fffff  99='(99) missing' ;
  VALUE V25fffff  99='(99) missing' ;
  VALUE V26fffff  99='(99) missing' ;
  VALUE V27fffff  99='(99) missing' ;
  VALUE V28fffff  99='(99) missing' ;
  VALUE V29fffff  99='(99) missing' ;
  VALUE V30fffff  99='(99) missing' ;
  VALUE V31fffff  88='(88) not applicable' ;
  VALUE V32fffff  88='(88) not applicable' ;
  VALUE V33fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V34fffff  88='(88) not applicable' ;
  VALUE V35fffff  88='(88) not applicable' ;
  VALUE V36fffff  88='(88) not applicable' ;
  VALUE V37fffff  8='(8) not applicable' ;
  VALUE V38fffff  9='(9) missing' ;
  VALUE V39fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V40fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V41fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V42fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V43fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V44fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V45fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V46fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V47fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V48fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V49fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V50fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V51fffff  88='(88) not applicable' ;
  VALUE V52fffff  88='(88) not applicable' ;
  VALUE V53fffff  88='(88) not applicable' ;
  VALUE V54fffff  88='(88) not applicable' ;
  VALUE V55fffff  88='(88) not applicable' ;
  VALUE V56fffff  88='(88) not applicable' ;
  VALUE V57fffff  88='(88) not applicable' ;
  VALUE V58fffff  88='(88) not applicable' ;
  VALUE V59fffff  88='(88) not applicable' ;
  VALUE V61fffff  88='(88) not applicable' ;
  VALUE V62fffff  88='(88) not applicable' ;
  VALUE V63fffff  88='(88) not applicable' ;
  VALUE V64fffff  88='(88) not applicable' ;
  VALUE V65fffff  88='(88) not applicable' ;
  VALUE V66fffff  88='(88) not applicable' ;
  VALUE V67fffff  88='(88) not applicable' ;
  VALUE V68fffff  88='(88) not applicable' ;
  VALUE V69fffff  88='(88) not applicable' ;
  VALUE V70fffff  88='(88) not applicable' ;
  VALUE V71fffff  88='(88) not applicable' ;
  VALUE V72fffff  88='(88) not applicable' ;
  VALUE V73fffff  88='(88) not applicable' ;
  VALUE V74fffff  88='(88) not applicable' ;
  VALUE V75fffff  88='(88) not applicable' ;
  VALUE V76fffff  88='(88) not applicable' ;
  VALUE V77fffff  88='(88) not applicable' ;
  VALUE V78fffff  88='(88) not applicable' ;
  VALUE V79fffff  88='(88) not applicable' ;
  VALUE V80fffff  88='(88) not applicable' ;
  VALUE V81fffff  88='(88) not applicable' ;
  VALUE V82fffff  88='(88) not applicable' ;
  VALUE V83fffff  88='(88) not applicable' ;
  VALUE V84fffff  88='(88) not applicable' ;
  VALUE V85fffff  88='(88) not applicable' ;
  VALUE V86fffff  88='(88) not applicable' ;
  VALUE V87fffff  88='(88) not applicable' ;
*/


* SAS DATA, INFILE, INPUT STATEMENTS;

DATA;
INFILE "data-filename" LRECL=165;
INPUT
        ID 1-4                  V23 5-6
        V19 7-8                 V3 9-10                 V4 11-12
        V5 13-14                V6 15-16                V7 17-18
        V8 19-20                V9 21-22                V10 23-24
        V11 25-26               V12 27-28               V13 29-30
        V14 31-32               V15 33-34               V16 35-36
        V17 37-38               V18 39                  V20 40
        V22 41                  V24 42-43               V25 44-45
        V26 46-47               V27 48-49               V28 50-51
        V29 52-53               V30 54-55               V31 56-57
        V32 58-59               V33 60-61               V34 62-63
        V35 64-65               V36 66-67               V37 68
        V38 69                  V39 70-71               V40 72-73
        V41 74-75               V42 76-77               V43 78-79
        V44 80-81               V45 82-83               V46 84-85
        V47 86-87               V48 88-89               V49 90-91
        V50 92-93               V51 94-95               V52 96-97
        V53 98-99               V54 100-101             V55 102-103
        V56 104-105             V57 106-107             V58 108-109
        V59 110-111             V61 112-113             V62 114-115
        V63 116-117             V64 118-119             V65 120-121
        V66 122-123             V67 124-125             V68 126-127
        V69 128-129             V70 130-131             V71 132-133
        V72 134-135             V73 136-137             V74 138-139
        V75 140-141             V76 142-143             V77 144-145
        V78 146-147             V79 148-149             V80 150-151
        V81 152-153             V82 154-155             V83 156-157
        V84 158-159             V85 160-161             V86 162-163
        V87 164-165             ;


* SAS LABEL STATEMENT;

LABEL
   ID      = 'PERSON ID NUMBER'
   V23     = 'ARREST SEQUENCE'
   V19     = 'NUMBER OF CONTACTS'
   V3      = 'DATE OF BIRTH - MONTH'
   V4      = 'DATE OF BIRTH - DAY'
   V5      = 'DATE OF BIRTH - YEAR'
   V6      = 'DATE OF INTERVIEW 1 - MONTH'
   V7      = 'DATE OF INTERVIEW 1 - DAY'
   V8      = 'DATE OF INTERVIEW 1 - YEAR'
   V9      = 'DATE OF INTERVIEW 2 - MONTH'
   V10     = 'DATE OF INTERVIEW 2 - DAY'
   V11     = 'DATE OF INTERVIEW 2 - YEAR'
   V12     = 'DATE OF INTERVIEW 3 - MONTH'
   V13     = 'DATE OF INTERVIEW 3 - DAY'
   V14     = 'DATE OF INTERVIEW 3 - YEAR'
   V15     = 'DATE OF DEATH - MONTH'
   V16     = 'DATE OF DEATH - DAY'
   V17     = 'DATE OF DEATH - YEAR'
   V18     = 'INSTITUTION AT TIME SELECTED'
   V20     = 'CODER'
   V22     = 'TIME PERIOD'
   V24     = 'DATE OF CONTACT - MONTH'
   V25     = 'DATE OF CONTACT - DAY'
   V26     = 'DATE OF CONTACT - YEAR'
   V27     = 'COURT LOCATION'
   V28     = 'CHARGE 1'
   V29     = 'CHARGE 1: COUNTS'
   V30     = 'CHARGE 1: DISPOSITION'
   V31     = 'CHARGE 2'
   V32     = 'CHARGE 2: COUNTS'
   V33     = 'CHARGE 2: DISPOSITION'
   V34     = 'CHARGE 3'
   V35     = 'CHARGE 3: COUNTS'
   V36     = 'CHARGE 3: DISPOSITION'
   V37     = 'CORRECTIONAL VIOLATION'
   V38     = 'TOTAL NUMBER OF CHARGES'
   V39     = 'PROBATION 1: START MONTH'
   V40     = 'PROBATION 1: START DAY'
   V41     = 'PROBATION 1: START YEAR'
   V42     = 'PROBATION 1: END MONTH'
   V43     = 'PROBATION 1: END DAY'
   V44     = 'PROBATION 1: END YEAR'
   V45     = 'INCARCERATION 1: START MONTH'
   V46     = 'INCARCERATION 1: START DAY'
   V47     = 'INCARCERATION 1: START YEAR'
   V48     = 'INCARCERATION 1: END MONTH'
   V49     = 'INCARCERATION 1: END DAY'
   V50     = 'INCARCERATION 1: END YEAR'
   V51     = 'PAROLE 1: START MONTH'
   V52     = 'PAROLE 1: START DAY'
   V53     = 'PAROLE 1: START YEAR'
   V54     = 'PAROLE 1: END MONTH'
   V55     = 'PAROLE 1: END DAY'
   V56     = 'PAROLE 1: END YEAR'
   V57     = 'PAROLE REVOCATION 1: MONTH'
   V58     = 'PAROLE REVOCATION 1: DAY'
   V59     = 'PAROLE REVOCATION 1: YEAR'
   V61     = 'INCARCERATION 2: START MONTH'
   V62     = 'INCARCERATION 2: START DAY'
   V63     = 'INCARCERATION 2: START YEAR'
   V64     = 'INCARCERATION 2: END MONTH'
   V65     = 'INCARCERATION 2: END DAY'
   V66     = 'INCARCERATION 2: END YEAR'
   V67     = 'PAROLE 2: START MONTH'
   V68     = 'PAROLE 2: START DAY'
   V69     = 'PAROLE 2: START YEAR'
   V70     = 'PAROLE 2: END MONTH'
   V71     = 'PAROLE 2: END DAY'
   V72     = 'PAROLE 2: END YEAR'
   V73     = 'PAROLE REVOCATION 2: MONTH'
   V74     = 'PAROLE REVOCATION 2: DAY'
   V75     = 'PAROLE REVOCATION 2: YEAR'
   V76     = 'INCARCERATION 3: START MONTH'
   V77     = 'INCARCERATION 3: START DAY'
   V78     = 'INCARCERATION 3: START YEAR'
   V79     = 'INCARCERATION 3: END MONTH'
   V80     = 'INCARCERATION 3: END DAY'
   V81     = 'INCARCERATION 3: END YEAR'
   V82     = 'PAROLE 3: START MONTH'
   V83     = 'PAROLE 3: START DAY'
   V84     = 'PAROLE 3: START YEAR'
   V85     = 'PAROLE 3: END MONTH'
   V86     = 'PAROLE 3: END DAY'
   V87     = 'PAROLE 3: END YEAR'
        ;


* USER-DEFINED MISSING VALUES RECODE TO SAS SYSMIS;

/*
   IF (V3 = 99) THEN V3 = .;
   IF (V4 = 99) THEN V4 = .;
   IF (V9 = 88) THEN V9 = .;
   IF (V10 = 88) THEN V10 = .;
   IF (V11 = 88) THEN V11 = .;
   IF (V12 = 88) THEN V12 = .;
   IF (V13 = 88) THEN V13 = .;
   IF (V14 = 88) THEN V14 = .;
   IF (V15 = 99) THEN V15 = .;
   IF (V16 = 99) THEN V16 = .;
   IF (V17 = 88) THEN V17 = .;
   IF (V24 = 99) THEN V24 = .;
   IF (V25 = 99) THEN V25 = .;
   IF (V26 = 99) THEN V26 = .;
   IF (V27 = 99) THEN V27 = .;
   IF (V28 = 99) THEN V28 = .;
   IF (V29 = 99) THEN V29 = .;
   IF (V30 = 99) THEN V30 = .;
   IF (V31 = 88) THEN V31 = .;
   IF (V32 = 88) THEN V32 = .;
   IF (V33 = 88 OR V33 = 99) THEN V33 = .;
   IF (V34 = 88) THEN V34 = .;
   IF (V35 = 88) THEN V35 = .;
   IF (V36 = 88) THEN V36 = .;
   IF (V37 = 8) THEN V37 = .;
   IF (V38 = 9) THEN V38 = .;
   IF (V39 = 88 OR V39 = 99) THEN V39 = .;
   IF (V40 = 88 OR V40 = 99) THEN V40 = .;
   IF (V41 = 88 OR V41 = 99) THEN V41 = .;
   IF (V42 = 88 OR V42 = 99) THEN V42 = .;
   IF (V43 = 88 OR V43 = 99) THEN V43 = .;
   IF (V44 = 88 OR V44 = 99) THEN V44 = .;
   IF (V45 = 88 OR V45 = 99) THEN V45 = .;
   IF (V46 = 88 OR V46 = 99) THEN V46 = .;
   IF (V47 = 88 OR V47 = 99) THEN V47 = .;
   IF (V48 = 88 OR V48 = 99) THEN V48 = .;
   IF (V49 = 88 OR V49 = 99) THEN V49 = .;
   IF (V50 = 88 OR V50 = 99) THEN V50 = .;
   IF (V51 = 88) THEN V51 = .;
   IF (V52 = 88) THEN V52 = .;
   IF (V53 = 88) THEN V53 = .;
   IF (V54 = 88) THEN V54 = .;
   IF (V55 = 88) THEN V55 = .;
   IF (V56 = 88) THEN V56 = .;
   IF (V57 = 88) THEN V57 = .;
   IF (V58 = 88) THEN V58 = .;
   IF (V59 = 88) THEN V59 = .;
   IF (V61 = 88) THEN V61 = .;
   IF (V62 = 88) THEN V62 = .;
   IF (V63 = 88) THEN V63 = .;
   IF (V64 = 88) THEN V64 = .;
   IF (V65 = 88) THEN V65 = .;
   IF (V66 = 88) THEN V66 = .;
   IF (V67 = 88) THEN V67 = .;
   IF (V68 = 88) THEN V68 = .;
   IF (V69 = 88) THEN V69 = .;
   IF (V70 = 88) THEN V70 = .;
   IF (V71 = 88) THEN V71 = .;
   IF (V72 = 88) THEN V72 = .;
   IF (V73 = 88) THEN V73 = .;
   IF (V74 = 88) THEN V74 = .;
   IF (V75 = 88) THEN V75 = .;
   IF (V76 = 88) THEN V76 = .;
   IF (V77 = 88) THEN V77 = .;
   IF (V78 = 88) THEN V78 = .;
   IF (V79 = 88) THEN V79 = .;
   IF (V80 = 88) THEN V80 = .;
   IF (V81 = 88) THEN V81 = .;
   IF (V82 = 88) THEN V82 = .;
   IF (V83 = 88) THEN V83 = .;
   IF (V84 = 88) THEN V84 = .;
   IF (V85 = 88) THEN V85 = .;
   IF (V86 = 88) THEN V86 = .;
   IF (V87 = 88) THEN V87 = .;
*/


* SAS FORMAT STATEMENT;

/*
  FORMAT V3 V3ffffff. V4 V4ffffff. V9 V9ffffff.
         V10 V10fffff. V11 V11fffff. V12 V12fffff.
         V13 V13fffff. V14 V14fffff. V15 V15fffff.
         V16 V16fffff. V17 V17fffff. V18 V18fffff.
         V20 V20fffff. V22 V22fffff. V24 V24fffff.
         V25 V25fffff. V26 V26fffff. V27 V27fffff.
         V28 V28fffff. V29 V29fffff. V30 V30fffff.
         V31 V31fffff. V32 V32fffff. V33 V33fffff.
         V34 V34fffff. V35 V35fffff. V36 V36fffff.
         V37 V37fffff. V38 V38fffff. V39 V39fffff.
         V40 V40fffff. V41 V41fffff. V42 V42fffff.
         V43 V43fffff. V44 V44fffff. V45 V45fffff.
         V46 V46fffff. V47 V47fffff. V48 V48fffff.
         V49 V49fffff. V50 V50fffff. V51 V51fffff.
         V52 V52fffff. V53 V53fffff. V54 V54fffff.
         V55 V55fffff. V56 V56fffff. V57 V57fffff.
         V58 V58fffff. V59 V59fffff. V61 V61fffff.
         V62 V62fffff. V63 V63fffff. V64 V64fffff.
         V65 V65fffff. V66 V66fffff. V67 V67fffff.
         V68 V68fffff. V69 V69fffff. V70 V70fffff.
         V71 V71fffff. V72 V72fffff. V73 V73fffff.
         V74 V74fffff. V75 V75fffff. V76 V76fffff.
         V77 V77fffff. V78 V78fffff. V79 V79fffff.
         V80 V80fffff. V81 V81fffff. V82 V82fffff.
         V83 V83fffff. V84 V84fffff. V85 V85fffff.
         V86 V86fffff. V87 V87fffff.  ;
*/

RUN ;
