*-------------------------------------------------------------------------*
 |                                                                         
 |               SAS COMPANION PROGRAM FILE FOR ICPSR 09735
 |        CRIMINAL CAREERS AND CRIME CONTROL IN MASSACHUSETTS [THE
 |         GLUECK STUDY]: A MATCHED-SAMPLE LONGITUDINAL RESEARCH
 |                       DESIGN, PHASE I, 1939-1963
 |                       (DATASET 0001:  DATA FILE)
 |
 |
 | This SAS program is provided for optional use with the SAS transport
 | version of this data file as distributed by ICPSR. The metadata provided
 | below are not stored in the SAS transport version of this data
 | collection.  Users need to use SAS PROC COPY to copy the SAS transport
 | file to a SAS data set on their system. This program can then be used in
 | conjunction with the SAS system data file.
 |
 | PROC FORMAT:  creates user-defined formats for the variables. Formats
 | replace original value codes with value code descriptions.  Only
 | variables with user-defined formats are included in this section.
 |
 | DATA:  begins a SAS data step and names an output SAS data set. Users
 | should replace "SAS-dataset" with their name for the SAS data set copied
 | from the SAS transport file. Users can add a SAS libname statement
 | and an output SAS data set name to make a permanent SAS data set.
 |
 | MISSING VALUE RECODES:  sets user-defined numeric missing values to
 | missing as interpreted by the SAS system. Only variables with
 | user-defined missing values are included in the section.
 |
 | FORMAT:  associates the formats created by the PROC FORMAT step with
 | the variables stored in the SAS data set. Users can refer to their
 | SAS manual for information on how to permanently store formats in a
 | SAS catalog.
 |
 | NOTE:  Users should modify these sections to suit their specific needs.
 | The MISSING VALUE RECODES section has been commented out (i.e., '/*'
 | and '*/').  To make this section active in the program, users should
 | remove the SAS comment indicators from this section.
 |
 *------------------------------------------------------------------------;

* SAS PROC FORMAT;

PROC FORMAT;
  VALUE V3ffffff  99='(99) blanked' ;
  VALUE V4ffffff  99='(99) blanked' ;
  VALUE V9ffffff  88='(88) not applicable' ;
  VALUE V10fffff  88='(88) not applicable' ;
  VALUE V11fffff  88='(88) not applicable' ;
  VALUE V12fffff  88='(88) not applicable' ;
  VALUE V13fffff  88='(88) not applicable' ;
  VALUE V14fffff  88='(88) not applicable' ;
  VALUE V15fffff  99='(99) blanked' ;
  VALUE V16fffff  99='(99) blanked' ;
  VALUE V17fffff  88='(88) not applicable' ;
  VALUE V18fffff  1='(1) Lyman (L.S.)' 2='(2) Shirley (I.S.B.)' 3='(3) other delinquent' ;
  VALUE V20fffff  1='(1) coder 1' 2='(2) coder 2' 3='(3) coder 3' 4='(4) coder 4' ;
  VALUE V22fffff  1='(1) time 1' 2='(2) time 2' 3='(3) time 3' ;
  VALUE V24fffff  99='(99) missing' ;
  VALUE V25fffff  99='(99) missing' ;
  VALUE V26fffff  99='(99) missing' ;
  VALUE V27fffff  99='(99) missing' ;
  VALUE V28fffff  99='(99) missing' ;
  VALUE V29fffff  99='(99) missing' ;
  VALUE V30fffff  99='(99) missing' ;
  VALUE V31fffff  88='(88) not applicable' ;
  VALUE V32fffff  88='(88) not applicable' ;
  VALUE V33fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V34fffff  88='(88) not applicable' ;
  VALUE V35fffff  88='(88) not applicable' ;
  VALUE V36fffff  88='(88) not applicable' ;
  VALUE V37fffff  8='(8) not applicable' ;
  VALUE V38fffff  9='(9) missing' ;
  VALUE V39fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V40fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V41fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V42fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V43fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V44fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V45fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V46fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V47fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V48fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V49fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V50fffff  88='(88) not applicable' 99='(99) missing' ;
  VALUE V51fffff  88='(88) not applicable' ;
  VALUE V52fffff  88='(88) not applicable' ;
  VALUE V53fffff  88='(88) not applicable' ;
  VALUE V54fffff  88='(88) not applicable' ;
  VALUE V55fffff  88='(88) not applicable' ;
  VALUE V56fffff  88='(88) not applicable' ;
  VALUE V57fffff  88='(88) not applicable' ;
  VALUE V58fffff  88='(88) not applicable' ;
  VALUE V59fffff  88='(88) not applicable' ;
  VALUE V61fffff  88='(88) not applicable' ;
  VALUE V62fffff  88='(88) not applicable' ;
  VALUE V63fffff  88='(88) not applicable' ;
  VALUE V64fffff  88='(88) not applicable' ;
  VALUE V65fffff  88='(88) not applicable' ;
  VALUE V66fffff  88='(88) not applicable' ;
  VALUE V67fffff  88='(88) not applicable' ;
  VALUE V68fffff  88='(88) not applicable' ;
  VALUE V69fffff  88='(88) not applicable' ;
  VALUE V70fffff  88='(88) not applicable' ;
  VALUE V71fffff  88='(88) not applicable' ;
  VALUE V72fffff  88='(88) not applicable' ;
  VALUE V73fffff  88='(88) not applicable' ;
  VALUE V74fffff  88='(88) not applicable' ;
  VALUE V75fffff  88='(88) not applicable' ;
  VALUE V76fffff  88='(88) not applicable' ;
  VALUE V77fffff  88='(88) not applicable' ;
  VALUE V78fffff  88='(88) not applicable' ;
  VALUE V79fffff  88='(88) not applicable' ;
  VALUE V80fffff  88='(88) not applicable' ;
  VALUE V81fffff  88='(88) not applicable' ;
  VALUE V82fffff  88='(88) not applicable' ;
  VALUE V83fffff  88='(88) not applicable' ;
  VALUE V84fffff  88='(88) not applicable' ;
  VALUE V85fffff  88='(88) not applicable' ;
  VALUE V86fffff  88='(88) not applicable' ;
  VALUE V87fffff  88='(88) not applicable' ;
RUN;

* SAS DATA STEP;
DATA;
SET SAS-dataset ;


* USER-DEFINED MISSING VALUES RECODE TO SAS SYSMIS;

/*
   IF (V3 = 99) THEN V3 = .;
   IF (V4 = 99) THEN V4 = .;
   IF (V9 = 88) THEN V9 = .;
   IF (V10 = 88) THEN V10 = .;
   IF (V11 = 88) THEN V11 = .;
   IF (V12 = 88) THEN V12 = .;
   IF (V13 = 88) THEN V13 = .;
   IF (V14 = 88) THEN V14 = .;
   IF (V15 = 99) THEN V15 = .;
   IF (V16 = 99) THEN V16 = .;
   IF (V17 = 88) THEN V17 = .;
   IF (V24 = 99) THEN V24 = .;
   IF (V25 = 99) THEN V25 = .;
   IF (V26 = 99) THEN V26 = .;
   IF (V27 = 99) THEN V27 = .;
   IF (V28 = 99) THEN V28 = .;
   IF (V29 = 99) THEN V29 = .;
   IF (V30 = 99) THEN V30 = .;
   IF (V31 = 88) THEN V31 = .;
   IF (V32 = 88) THEN V32 = .;
   IF (V33 = 88 OR V33 = 99) THEN V33 = .;
   IF (V34 = 88) THEN V34 = .;
   IF (V35 = 88) THEN V35 = .;
   IF (V36 = 88) THEN V36 = .;
   IF (V37 = 8) THEN V37 = .;
   IF (V38 = 9) THEN V38 = .;
   IF (V39 = 88 OR V39 = 99) THEN V39 = .;
   IF (V40 = 88 OR V40 = 99) THEN V40 = .;
   IF (V41 = 88 OR V41 = 99) THEN V41 = .;
   IF (V42 = 88 OR V42 = 99) THEN V42 = .;
   IF (V43 = 88 OR V43 = 99) THEN V43 = .;
   IF (V44 = 88 OR V44 = 99) THEN V44 = .;
   IF (V45 = 88 OR V45 = 99) THEN V45 = .;
   IF (V46 = 88 OR V46 = 99) THEN V46 = .;
   IF (V47 = 88 OR V47 = 99) THEN V47 = .;
   IF (V48 = 88 OR V48 = 99) THEN V48 = .;
   IF (V49 = 88 OR V49 = 99) THEN V49 = .;
   IF (V50 = 88 OR V50 = 99) THEN V50 = .;
   IF (V51 = 88) THEN V51 = .;
   IF (V52 = 88) THEN V52 = .;
   IF (V53 = 88) THEN V53 = .;
   IF (V54 = 88) THEN V54 = .;
   IF (V55 = 88) THEN V55 = .;
   IF (V56 = 88) THEN V56 = .;
   IF (V57 = 88) THEN V57 = .;
   IF (V58 = 88) THEN V58 = .;
   IF (V59 = 88) THEN V59 = .;
   IF (V61 = 88) THEN V61 = .;
   IF (V62 = 88) THEN V62 = .;
   IF (V63 = 88) THEN V63 = .;
   IF (V64 = 88) THEN V64 = .;
   IF (V65 = 88) THEN V65 = .;
   IF (V66 = 88) THEN V66 = .;
   IF (V67 = 88) THEN V67 = .;
   IF (V68 = 88) THEN V68 = .;
   IF (V69 = 88) THEN V69 = .;
   IF (V70 = 88) THEN V70 = .;
   IF (V71 = 88) THEN V71 = .;
   IF (V72 = 88) THEN V72 = .;
   IF (V73 = 88) THEN V73 = .;
   IF (V74 = 88) THEN V74 = .;
   IF (V75 = 88) THEN V75 = .;
   IF (V76 = 88) THEN V76 = .;
   IF (V77 = 88) THEN V77 = .;
   IF (V78 = 88) THEN V78 = .;
   IF (V79 = 88) THEN V79 = .;
   IF (V80 = 88) THEN V80 = .;
   IF (V81 = 88) THEN V81 = .;
   IF (V82 = 88) THEN V82 = .;
   IF (V83 = 88) THEN V83 = .;
   IF (V84 = 88) THEN V84 = .;
   IF (V85 = 88) THEN V85 = .;
   IF (V86 = 88) THEN V86 = .;
   IF (V87 = 88) THEN V87 = .;
*/

* SAS FORMAT STATEMENT;

  FORMAT V3 V3ffffff. V4 V4ffffff. V9 V9ffffff.
         V10 V10fffff. V11 V11fffff. V12 V12fffff.
         V13 V13fffff. V14 V14fffff. V15 V15fffff.
         V16 V16fffff. V17 V17fffff. V18 V18fffff.
         V20 V20fffff. V22 V22fffff. V24 V24fffff.
         V25 V25fffff. V26 V26fffff. V27 V27fffff.
         V28 V28fffff. V29 V29fffff. V30 V30fffff.
         V31 V31fffff. V32 V32fffff. V33 V33fffff.
         V34 V34fffff. V35 V35fffff. V36 V36fffff.
         V37 V37fffff. V38 V38fffff. V39 V39fffff.
         V40 V40fffff. V41 V41fffff. V42 V42fffff.
         V43 V43fffff. V44 V44fffff. V45 V45fffff.
         V46 V46fffff. V47 V47fffff. V48 V48fffff.
         V49 V49fffff. V50 V50fffff. V51 V51fffff.
         V52 V52fffff. V53 V53fffff. V54 V54fffff.
         V55 V55fffff. V56 V56fffff. V57 V57fffff.
         V58 V58fffff. V59 V59fffff. V61 V61fffff.
         V62 V62fffff. V63 V63fffff. V64 V64fffff.
         V65 V65fffff. V66 V66fffff. V67 V67fffff.
         V68 V68fffff. V69 V69fffff. V70 V70fffff.
         V71 V71fffff. V72 V72fffff. V73 V73fffff.
         V74 V74fffff. V75 V75fffff. V76 V76fffff.
         V77 V77fffff. V78 V78fffff. V79 V79fffff.
         V80 V80fffff. V81 V81fffff. V82 V82fffff.
         V83 V83fffff. V84 V84fffff. V85 V85fffff.
         V86 V86fffff. V87 V87fffff.  ;

RUN ;
