library(fda)
library(ggplot2)

# X-ove a Y-ove souradnice zvlast
dfx <- data.frame(time = handwritTime, sx = c(handwrit[, , 1]), coord = "X(t)",
                  sample = factor(rep(1:20, each = length(handwritTime))))

dfy <- data.frame(time = handwritTime, sx = c(handwrit[, , 2]), coord = "Y(t)",
                  sample = factor(rep(1:20, each = length(handwritTime))))

df <- rbind(dfx, dfy)

p <- ggplot(df, aes(x = time, y = sx, colour = sample, group = sample))
p <- p + geom_line()
p <- p + facet_grid(coord ~ .)
p <- p + labs (x = "Time [ms]", y = "Position [mm]") 
p <- p + theme_bw ()
print (p)

dev.copy2pdf (file = "xy.pdf", width = 12, height = 7)

# cely napis
df <- data.frame(time = handwritTime, sx = c(handwrit[, , 1]), sy = c(handwrit[, , 2]),
                  sample = factor(rep(1:20, each = length(handwritTime))))


p <- ggplot(df, aes(x = sx, y = sy, colour = sample, group = sample))
p <- p + geom_path()
p <- p + labs (x = "Position [mm]", y = "Position [mm]") 
p <- p + theme_bw ()
print (p)

dev.copy2pdf (file = "napis.pdf", width = 12, height = 7)

# jen cast rady
handpart <- handwrit[1:200,1:10,1]
handwritTimepart <- handwritTime[1:200]

dfpart <- data.frame(time = handwritTimepart, sx = c(handpart),
                  sample = factor(rep(1:10, each = length(handwritTimepart))))

p <- ggplot(dfpart, aes(x = time, y = sx, colour = sample, group = sample))
p <- p + geom_point(size = 0.5)
p <- p + labs (x = "Time [ms]", y = "Position [mm]") 
p <- p + theme_bw ()
print (p)

dev.copy2pdf (file = "xypart.pdf", width = 12, height = 7)
