library (iterators)
library (reshape2) 
library (foreach) 
library (plyr)
library (gplots)
library (ggplot2)
library (rgl)  
library (fda)  
# source ("npfda.R")

# generovani ekvidistantni body - 1 mereni

n <- 1
T <- 24
x <- 1:T
xx <- seq(from = x[1], t = x[length(x)], length.out = 50)
eps <- rnorm(T, sd = 1/2)
#a <- runif(n)
a <- 0.4

mx <- sin(a*x) - a/4*x
y <-  mx + eps

df <- data.frame(x = x, y = y, mx = mx)

save(file = "mereni1.RData", list = c("df", "y", "x"))
load("mereni1.RData")

# vykresleni bodu
x11()
p0 <- ggplot (data = df, aes (x = x, y = y))
  p0 <- p0 + geom_point (colour = 2)
#  p0 <- p0 + geom_line(y = mx)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = "measur1samp.pdf", width = 10, height = 7)


# vykresleni krivek
x11()
  p0 <- ggplot (data = df, aes (x = x, y = y))
  p0 <- p0 + geom_line (colour = 2)
  p0 <- p0 + geom_point (colour = 2)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = "curve1samp.pdf", width = 10, height = 7)

# LRM

mod <- lm(y ~ x, data = df)
summary(mod)
x11()
p0 <- ggplot (data = df, aes (x = x, y = y))
p0 <- p0 + geom_point (colour = 2)
#p0 <- p0 + geom_smooth (method = "lm", formula = y ~ x + I(x^2) + I(x^3), colour = 1, se = FALSE, size = 1.5)
p0 <- p0 + geom_smooth (method = "loess", colour = 1, se = FALSE, size = 1.5)
p0 <- p0 + geom_line (aes (y = mx), colour = 4, linetype = 2, size = 1.5)
p0 <- p0 + labs (x = "Time", y = "Observation") 
p0 <- p0 + theme_bw ()
p0 <- p0 + scale_x_continuous (breaks = 1:T)
print (p0)

dev.copy2pdf (file = paste0("loesssamp1.pdf"), width = 10, height = 7)

# FDA

# pokus
plotGCVRMSE.fd = function(lamlow, lamhi, lamdel, x, argvals, y,
                          fdParobj, wtvec=NULL, fdnames=NULL, covariates=NULL) {
  loglamvec = seq(lamlow, lamhi, lamdel)
  loglamout = matrix(0,length(loglamvec),4)
  m = 0
  for (loglambda in loglamvec) {
    m = m + 1
    loglamout[m,1] = loglambda
    fdParobj$lambda = 10^(loglambda)
    smoothlist = smooth.basis(argvals, y, fdParobj, wtvec=wtvec,
                              fdnames=fdnames, covariates=covariates)
    xfd = smoothlist$fd # the curve smoothing the data
    loglamout[m,2] = smoothlist$df
    # degrees of freedom in the smoothing curve
    loglamout[m,3] = sqrt(mean((eval.fd(argvals, xfd) - x)^2))
    loglamout[m,4] = mean(smoothlist$gcv) # the mean of the N gcv values
  }
  cat("log10 lambda, deg. freedom, RMSE, gcv\n")
  for (i in 1:m) {
    cat(format(round(loglamout[i,],3)))
    cat("\n")
  }
  par(mfrow=c(3,1))
  plot(loglamvec, loglamout[,2], type="b")
  title("Degrees of freedom")
  plot(loglamvec, loglamout[,3], type="b")
  title("RMSE")
  plot(loglamvec, loglamout[,4], type="b")
  title("Mean gcv")
  return(loglamout)
}


# nejprve zvolime "knots" pro splajny
(knots <- c(seq(1, T, by = 4), 24))
rozsah <- range(knots)
# rad B-splajnu
norder <- 4

# odtud plyne velikost baze
nbasis <- length (knots) + norder - 2

# Vytvorime bazi splajnu
bbasis <- create.bspline.basis (rozsah, nbasis, norder, knots)

# kolik mame krivek?
n <- 1

# Vytvorime "Lfd" objekty, dve moznosti:
# 1. int2Lfd -- just penalize some derivatives. 
curv.Lfd <- int2Lfd (2)

# 2. vec2Lfd -- a (constant) linear combination of derivatives; for technical
# reasons this also requires the range of the basis. 
# harmLfd <- vec2Lfd (c(1, (2*pi/98)^2, 0), rangeval = rozsah)

#   # definujeme vyhlazovaci parametr lambda
lambda <- 10^(-6)
# 
# # definujeme "fdPar" objekt 
curv.fdPar <- fdPar (bbasis, curv.Lfd, lambda)
# 
W <- data.frame(NULL)

# Jak vybrat lambda?

loglamout = plotGCVRMSE.fd(-6, 2, 0.25, mx, x, y, curv.fdPar)

# cyklus WHILE
lambdas <- 10^(-6)
mean.gcv2 <- mean.gcv1 <- 10^8
# pokud je v dalsim kroku gcv vetsi, skonci se
while (mean.gcv1 >= mean.gcv2){
  mean.gcv1 <- mean.gcv2
  lambdas <- lambdas * 10^(1/2)
  # nastavime lambda
  curv.fdPari <- curv.fdPar
  curv.fdPari$lambda <- lambdas
  
  # hladime
  tempSmoothi <- smooth.basis(x, y, curv.fdPari)
  
  # ulozime prumerne GCV
  mean.gcv2 <- mean(tempSmoothi$gcv)
}

# Vybereme nejlepsi a podle neho nadefinujeme hladkou bazi
lambdabest <- lambdas * 10^(-1/2)
curv.fdPar$lambda <- lambdabest/5
# hladime
tempSmooth <- smooth.basis(x, y, curv.fdPar)

# A vykreslime vyslednou bazi
xx <- seq(from = x[1], t = x[length(x)], length.out = 50)
fdobjSmooth <- tempSmooth$fd
fdobjSmooth_der1 <- deriv.fd(tempSmooth$fd, 1) # 1. derivace
fdobjSmooth_der2 <- deriv.fd(tempSmooth$fd, 2) # 2. derivace
fdobjSmootheval <- eval.fd(fdobj = fdobjSmooth, evalarg = xx)
meanfdobjSmootheval <- eval.fd(fdobj = mean(fdobjSmooth), evalarg = xx)
fdobjSmootheval_der1 <- eval.fd(fdobj = fdobjSmooth_der1, evalarg = xx)
fdobjSmootheval_der2 <- eval.fd(fdobj = fdobjSmooth_der2, evalarg = xx)
# 2 moznosti pro vykresleni, obe stejne
# par(mfrow=c(2,1))
# matplot(xx, fdobjSmootheval, type = "l")
# plot(fdobjSmooth)

dffda <- data.frame(x = xx, mean = meanfdobjSmootheval, fdacurves = fdobjSmootheval)

# meanova krivka
x11()
p0 <- ggplot ()
p0 <- p0 + geom_point (data = df, aes (x = x, y = y), colour = 2)
p0 <- p0 + geom_line (data = df, aes (x = x, y = mx), colour = 4, linetype = 2, size = 1.5)
p0 <- p0 + geom_line (data = dffda, aes (x = xx, y = mean), colour = 1, size = 1.5)
p0 <- p0 + labs (x = "Time", y = "Observation") 
p0 <- p0 + theme_bw ()
p0 <- p0 + scale_x_continuous (breaks = 1:T)
print (p0)

dev.copy2pdf (file = paste0("meanfda1sample.pdf"), width = 10, height = 7)


# generovani ekvidistantni body

n <- 10
T <- 24
x <- 1:T
y <- matrix(NA, nrow = n, ncol = T)
eps <- matrix(rnorm(n*T, sd = 0.2), c(n, T))
#a <- runif(n)
a <- rep(0.1, n)

for (k in (1:n)){
 y[k, ] <-  sin(a[k] * x) + eps[k, ]
}

save(file = "mereni.RData", list = c("df", "y", "x"))
load("mereni.RData")

df <- data.frame(x = x, y = c(t(y)), samp = factor(rep(1:n, each = T)))

# vykresleni bodu
x11()
for (k in (1:n)){
p0 <- ggplot (data = df[1:(k*T), ], aes (x = x, y = y, colour = samp))
p0 <- p0 + geom_point ()
#p0 <- p0 + guides (colour = FALSE) 
p0 <- p0 + labs (x = "Time", y = "Observation") 
p0 <- p0 + theme_bw ()
p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
  #axis.text = element_text (size = fontsize), axis.title = element_text (size = fontsize), 
#                   plot.title = element_text(hjust = 0.5, size = fontsize + 4))
# p0 <- p0 + geom_text (aes (x = 0, y = 90, label = "10k, SS-7, n = 79"), inherit.aes = F, size = 8)
p0 <- p0 + scale_x_continuous (breaks = 1:T)
print (p0)

dev.copy2pdf (file = paste0("measur",k,".pdf"), width = 10, height = 7)
}

# vykresleni krivek
x11()
for (k in (1:n)){
  p0 <- ggplot (data = df[1:(k*T), ], aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_line ()
  p0 <- p0 + geom_point ()
  #p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
  #axis.text = element_text (size = fontsize), axis.title = element_text (size = fontsize), 
  #                   plot.title = element_text(hjust = 0.5, size = fontsize + 4))
  # p0 <- p0 + geom_text (aes (x = 0, y = 90, label = "10k, SS-7, n = 79"), inherit.aes = F, size = 8)
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = paste0("curve",k,".pdf"), width = 10, height = 7)
}

# LRM

mod <- lm(y ~ x, data = df)
summary(mod)
x11()
p0 <- ggplot (data = df[1:(10*T), ], aes (x = x, y = y, colour = samp))
p0 <- p0 + geom_point ()
p0 <- p0 + guides (colour = FALSE) 
p0 <- p0 + geom_smooth (method = "lm", formula = y ~ x + I(x^2) + I(x^3) +I(x^4), colour = 1, se = FALSE, size = 1.5)
# p0 <- p0 + geom_smooth (method = "loess", colour = 1, se = FALSE, size = 1.5)
p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
p0 <- p0 + labs (x = "Time", y = "Observation") 
p0 <- p0 + theme_bw ()
p0 <- p0 + scale_x_continuous (breaks = 1:T)
print (p0)

dev.copy2pdf (file = paste0("lm4.pdf"), width = 10, height = 7)

# FDA

# nejprve zvolime "knots" pro splajny
(knots <- c(seq(1, T, by = 4), 24))
rozsah <- range(knots)
# rad B-splajnu
norder <- 4

# odtud plyne velikost baze
nbasis <- length (knots) + norder - 2

# Vytvorime bazi splajnu
bbasis <- create.bspline.basis (rozsah, nbasis, norder, knots)

# kolik mame krivek?
n <- n

# Vytvorime "Lfd" objekty, dve moznosti:
# 1. int2Lfd -- just penalize some derivatives. 
curv.Lfd <- int2Lfd (2)

# 2. vec2Lfd -- a (constant) linear combination of derivatives; for technical
# reasons this also requires the range of the basis. 
# harmLfd <- vec2Lfd (c(1, (2*pi/98)^2, 0), rangeval = rozsah)

#   # definujeme vyhlazovaci parametr lambda
lambda <- 10
# 
# # definujeme "fdPar" objekt 
curv.fdPar <- fdPar (bbasis, curv.Lfd, lambda)
# 
W <- data.frame(NULL)

# Jak vybrat lambda?
# cyklus WHILE
  lambdas <- 10
mean.gcv2 <- mean.gcv1 <- 10^8
# pokud je v dalsim kroku gcv vetsi, skonci se
while (mean.gcv1 >= mean.gcv2){
  mean.gcv1 <- mean.gcv2
  lambdas <- lambdas * 10^(1/2)
  # nastavime lambda
  curv.fdPari <- curv.fdPar
  curv.fdPari$lambda <- lambdas

  # hladime
    tempSmoothi <- smooth.basis(x, t(y), curv.fdPari)
    
  # ulozime prumerne GCV
  mean.gcv2 <- mean(tempSmoothi$gcv)
}
  
  # Vybereme nejlepsi a podle neho nadefinujeme hladkou bazi
  lambdabest <- lambdas * 10^(-1/2)
  curv.fdPar$lambda <- lambdabest/5
  # hladime
  tempSmooth <- smooth.basis(x, t(y), curv.fdPar)
  
  # A vykreslime vyslednou bazi
  xx <- x
  fdobjSmooth <- tempSmooth$fd
  fdobjSmooth_der1 <- deriv.fd(tempSmooth$fd, 1) # 1. derivace
  fdobjSmooth_der2 <- deriv.fd(tempSmooth$fd, 2) # 2. derivace
  fdobjSmootheval <- eval.fd(fdobj = fdobjSmooth, evalarg = xx)
  meanfdobjSmootheval <- eval.fd(fdobj = mean(fdobjSmooth), evalarg = xx)
  fdobjSmootheval_der1 <- eval.fd(fdobj = fdobjSmooth_der1, evalarg = xx)
  fdobjSmootheval_der2 <- eval.fd(fdobj = fdobjSmooth_der2, evalarg = xx)
  # 2 moznosti pro vykresleni, obe stejne
  # par(mfrow=c(2,1))
  # matplot(xx, fdobjSmootheval, type = "l")
  # plot(fdobjSmooth)

  df$meanfda <- rep(meanfdobjSmootheval, times = n)
  df$fdacurves <- c(fdobjSmootheval)
  
  # meanova krivka
  x11()
  p0 <- ggplot (data = df[1:(10*T), ], aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point ()
  p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line (aes (y = meanfda), colour = 1, size = 1.5)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = paste0("meanfda.pdf"), width = 10, height = 7)
  
  # vsechny krivky
  x11()
  p0 <- ggplot (data = df[1:(10*T), ], aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point ()
  #p0 <- p0 + guides (colour = FALSE) 
#  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line (aes (y = fdacurves))
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = paste0("smcurves.pdf"), width = 10, height = 7)

#_____________________________________  
  # generovani nahodne body
  
  n <- 10
  T <- 24
  xran <- matrix(NA, nrow = n, ncol = T)
  yran <- matrix(NA, nrow = n, ncol = T)
  eps <- matrix(rnorm(n*T, sd = 0.2), c(n, T))
  #a <- runif(n)
  a <- rep(0.1, n)
  
  for (k in (1:n)){
    xr <- runif(T, min = 1, max = T)
    xran[k, ] <- xr
    yran[k, ] <-  sin(a[k] * xr) + eps[k, ]
  }
  
  
  dfran <- data.frame(x = c(t(xran)), y = c(t(yran)), samp = factor(rep(1:n, each = T)))

  save(file = "mereniran.RData", list = c("dfran", "xran", "yran"))
  load("mereniran.RData")
  
  # vykresleni bodu
  x11()
  for (k in (1:n)){
    p0 <- ggplot (data = dfran[1:(k*T), ], aes (x = x, y = y, colour = samp))
    p0 <- p0 + geom_point ()
    #p0 <- p0 + guides (colour = FALSE) 
    p0 <- p0 + labs (x = "Time", y = "Observation") 
    p0 <- p0 + theme_bw ()
    p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
    #axis.text = element_text (size = fontsize), axis.title = element_text (size = fontsize), 
    #                   plot.title = element_text(hjust = 0.5, size = fontsize + 4))
    # p0 <- p0 + geom_text (aes (x = 0, y = 90, label = "10k, SS-7, n = 79"), inherit.aes = F, size = 8)
    p0 <- p0 + scale_x_continuous (breaks = 1:T)
    print (p0)
    
    dev.copy2pdf (file = paste0("measurran",k,".pdf"), width = 10, height = 7)
  }
  
  # vykresleni krivek
  x11()
  for (k in (1:n)){
    p0 <- ggplot (data = dfran[1:(k*T), ], aes (x = x, y = y, colour = samp))
    p0 <- p0 + geom_line ()
    p0 <- p0 + geom_point ()
    #p0 <- p0 + guides (colour = FALSE) 
    p0 <- p0 + labs (x = "Time", y = "Observation") 
    p0 <- p0 + theme_bw ()
    p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
    #axis.text = element_text (size = fontsize), axis.title = element_text (size = fontsize), 
    #                   plot.title = element_text(hjust = 0.5, size = fontsize + 4))
    # p0 <- p0 + geom_text (aes (x = 0, y = 90, label = "10k, SS-7, n = 79"), inherit.aes = F, size = 8)
    p0 <- p0 + scale_x_continuous (breaks = 1:T)
    print (p0)
    
    dev.copy2pdf (file = paste0("curveran",k,".pdf"), width = 10, height = 7)
  }
  
  # LRM
  
  mod <- lm(y ~ x, data = dfran)
  summary(mod)
  x11()
  p0 <- ggplot (data = dfran, aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point ()
  p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + geom_smooth (method = "lm", formula = y ~ x + I(x^2) + I(x^3), colour = 1, se = FALSE, size = 1.5)
  # p0 <- p0 + geom_smooth (method = "loess", colour = 1, se = FALSE, size = 1.5)
  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = paste0("lm3ran.pdf"), width = 10, height = 7)

  # FDA
  tecka <- list()
  ypska <- list()
  for (k in (1:n)) {
    a <- subset (dfran, samp == k)
    ind <- order(a$x)
    tecka[[k]] <- a$x[ind]
    ypska[[k]] <- a$y[ind]
  }
  
  res <- FPCA(ypska, tecka, optns = list(dataType = 'Sparse', userBwMu = 2))#, error=FALSE, kernel='epan', verbose=TRUE))
  # plot(res)
  # CreatePathPlot(res, subset = 1:10, K = 3, pch = 20, xlab = "total Mh", ylab = "Fe", main = "Fe vs. total Mh")
  # 
  koef <- res$xiEst[,1:3] # koeficienty u prvnich 3 komponent
  iks <- res$workGrid  # sit x, kde jsou komponenty vyhodnoceny
  compon <- res$phi[, 1:3] # hlavni komponenty v x
  odh <- matrix(rep(1, times = n), c(n, 1)) %*% res$mu + koef %*% t(compon) # rekonstrukce
#  matplot(iks, t(odh), type = "l") 

  dfransparse <- data.frame(x = rep(iks, times = n), y = c(t(odh)),samp = factor(rep(1:n, each = length(iks))))
  dfransparse$meanfda <- res$mu
  
  # meanova krivka
  x11()
  p0 <- ggplot (data = dfransparse, aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point (data = dfran, aes(x = x, y = y, colour = samp))
  p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line (aes (y = meanfda), colour = 1, size = 1.5)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = paste0("meanfdaran.pdf"), width = 10, height = 7)
  
  # vsechny krivky
  x11()
  p0 <- ggplot (data = dfransparse, aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point (data = dfran, aes(x = x, y = y, colour = samp))
  #p0 <- p0 + guides (colour = FALSE) 
  #  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line ()
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = paste0("smcurvesran.pdf"), width = 10, height = 7)
  
  #_____________________________________  
  # generovani nahodne body, ruzne delky
  
  n <- 10
  T <- 24
  xranmiss <- matrix(NA, nrow = n, ncol = T)
  yranmiss <- matrix(NA, nrow = n, ncol = T)
  epsmiss <- matrix(rnorm(n*T, sd = 0.2), c(n, T))
  #a <- runif(n)
  a <- rep(0.1, n)
  
  for (k in (1:n)){
#    Tran <- round(runif(1, min = 4, max = 24))
    Tran <- sample.int(24, 1, prob = c(0, 0, 0, 2, 3, 5, 6, 4, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1)/24)
    xr <- runif(Tran, min = 1, max = Tran)
    xranmiss[k, 1:Tran] <- xr
    yranmiss[k, 1:Tran] <-  sin(a[k] * xr) + epsmiss[k, 1:Tran]
  }
  
  dfranmiss <- data.frame(x = c(t(xranmiss)), y = c(t(yranmiss)), samp = factor(rep(1:n, each = T)))
  
  save(file = "merenimiss.RData", list = c("dfranmiss", "xranmiss", "yranmiss"))
  load("merenimiss.RData")
  
  Ymin <- min(yranmiss, na.rm = TRUE)
  Ymax <- max(yranmiss, na.rm = TRUE)
  
  # vykresleni bodu
  x11()
  for (k in (1:n)){
    p0 <- ggplot (data = na.omit(dfranmiss[1:(k*T), ]), aes (x = x, y = y, colour = samp))
    p0 <- p0 + geom_point ()
    #p0 <- p0 + guides (colour = FALSE) 
    p0 <- p0 + labs (x = "Time", y = "Observation") 
    p0 <- p0 + theme_bw ()
    p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
    #axis.text = element_text (size = fontsize), axis.title = element_text (size = fontsize), 
    #                   plot.title = element_text(hjust = 0.5, size = fontsize + 4))
    # p0 <- p0 + geom_text (aes (x = 0, y = 90, label = "10k, SS-7, n = 79"), inherit.aes = F, size = 8)
    p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
    p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
    print (p0)
    
  #  dev.copy2pdf (file = paste0("measurmiss",k,".pdf"), width = 10, height = 7)
  }
  
  # vykresleni krivek
  x11()
  for (k in (1:n)){
    p0 <- ggplot (data = na.omit(dfranmiss[1:(k*T), ]), aes (x = x, y = y, colour = samp))
    p0 <- p0 + geom_line ()
    p0 <- p0 + geom_point ()
    #p0 <- p0 + guides (colour = FALSE) 
    p0 <- p0 + labs (x = "Time", y = "Observation") 
    p0 <- p0 + theme_bw ()
    p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
    #axis.text = element_text (size = fontsize), axis.title = element_text (size = fontsize), 
    #                   plot.title = element_text(hjust = 0.5, size = fontsize + 4))
    # p0 <- p0 + geom_text (aes (x = 0, y = 90, label = "10k, SS-7, n = 79"), inherit.aes = F, size = 8)
    p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
    p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
    print (p0)
    
    dev.copy2pdf (file = paste0("curvemiss",k,".pdf"), width = 10, height = 7)
  }
  
  # LRM
  
  mod <- lm(y ~ x, data = dfranmiss)
  summary(mod)
  x11()
  p0 <- ggplot (data = na.omit(dfranmiss), aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point ()
  p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + geom_smooth (method = "lm", formula = y ~ x + I(x^2) + I(x^3), colour = 1, se = FALSE, size = 1.5)
  # p0 <- p0 + geom_smooth (method = "loess", colour = 1, se = FALSE, size = 1.5)
  p0 <- p0 + geom_line (data = dfran, aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
  p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
  print (p0)
  
  dev.copy2pdf (file = paste0("lm3miss.pdf"), width = 10, height = 7)
  
  tecka <- list()
  ypska <- list()
  for (k in (1:n)) {
    a <- subset (na.omit(dfranmiss), samp == k)
    ind <- order(a$x)
    tecka[[k]] <- a$x[ind]
    ypska[[k]] <- a$y[ind]
  }
  
  res <- FPCA(ypska, tecka, optns = list(dataType = 'Sparse', userBwMu = 5))#, error=FALSE, kernel='epan', verbose=TRUE))
  # plot(res)
  CreatePathPlot(res, subset = 1:10, K = 3, pch = 20, xlab = "total Mh", ylab = "Fe", main = "Fe vs. total Mh")
  # 
  koef <- res$xiEst[,1:3] # koeficienty u prvnich 3 komponent
  iks <- res$workGrid  # sit x, kde jsou komponenty vyhodnoceny
  compon <- res$phi[, 1:3] # hlavni komponenty v x
  odh <- matrix(rep(1, times = n), c(n, 1)) %*% res$mu + koef %*% t(compon) # rekonstrukce
  #  matplot(iks, t(odh), type = "l") 
  
  dfransparse <- data.frame(x = rep(iks, times = n), y = c(t(odh)),samp = factor(rep(1:n, each = length(iks))))
  dfransparse$meanfda <- res$mu
  
  # meanova krivka
  x11()
  p0 <- ggplot (data = dfransparse, aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point (data = na.omit(dfranmiss), aes(x = x, y = y, colour = samp))
  p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line (aes (y = meanfda), colour = 1, size = 1.5)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
  p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
  print (p0)
  
  dev.copy2pdf (file = paste0("meanfdamiss.pdf"), width = 10, height = 7)
  
  # vsechny krivky
  x11()
  p0 <- ggplot (data = dfransparse, aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point (data = na.omit(dfranmiss), aes(x = x, y = y, colour = samp))
  #p0 <- p0 + guides (colour = FALSE) 
  #  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line ()
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
  p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
  print (p0)
  
  dev.copy2pdf (file = paste0("smcurvesmiss.pdf"), width = 10, height = 7)

  #_____________________________________  
  # generovani nahodne body, rostouci rozptyl
  
  n <- 10
  T <- 24
  xranvar <- matrix(NA, nrow = n, ncol = T)
  yranvar <- matrix(NA, nrow = n, ncol = T)
  epsvar <- matrix(rnorm(n*T, sd = rep((1:24)/10, times = n)), c(n, T))
  #a <- runif(n)
  a <- rep(0.1, n)
  
  for (k in (1:n)){
    Tran <- 24
    xr <- runif(Tran, min = 1, max = Tran)
    xranvar[k, 1:Tran] <- xr
    yranvar[k, 1:Tran] <-  sin(a[k] * xr) + epsvar[k, 1:Tran]
  }
  
  dfranvar <- data.frame(x = c(t(xranvar)), y = c(t(yranvar)), samp = factor(rep(1:n, each = T)))
  
  save(file = "merenivar.RData", list = c("dfranvar", "xranvar", "yranvar"))
  load("merenivar.RData")
  
  Ymin <- min(yranvar, na.rm = TRUE)
  Ymax <- max(yranvar, na.rm = TRUE)
  
  # vykresleni bodu
  x11()
  for (k in (1:n)){
    p0 <- ggplot (data = dfranvar[1:(k*T), ], aes (x = x, y = y, colour = samp))
    p0 <- p0 + geom_point ()
    #p0 <- p0 + guides (colour = FALSE) 
    p0 <- p0 + labs (x = "Time", y = "Observation") 
    p0 <- p0 + theme_bw ()
    p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
    #axis.text = element_text (size = fontsize), axis.title = element_text (size = fontsize), 
    #                   plot.title = element_text(hjust = 0.5, size = fontsize + 4))
    # p0 <- p0 + geom_text (aes (x = 0, y = 90, label = "10k, SS-7, n = 79"), inherit.aes = F, size = 8)
    p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
    p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
    print (p0)
    
    dev.copy2pdf (file = paste0("measurvar",k,".pdf"), width = 10, height = 7)
  }
  
  # vykresleni krivek
  x11()
  for (k in (1:n)){
    p0 <- ggplot (data = dfranvar[1:(k*T), ], aes (x = x, y = y, colour = samp))
    p0 <- p0 + geom_line ()
    p0 <- p0 + geom_point ()
    #p0 <- p0 + guides (colour = FALSE) 
    p0 <- p0 + labs (x = "Time", y = "Observation") 
    p0 <- p0 + theme_bw ()
    p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
    #axis.text = element_text (size = fontsize), axis.title = element_text (size = fontsize), 
    #                   plot.title = element_text(hjust = 0.5, size = fontsize + 4))
    # p0 <- p0 + geom_text (aes (x = 0, y = 90, label = "10k, SS-7, n = 79"), inherit.aes = F, size = 8)
    p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
    p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
    print (p0)
    
    dev.copy2pdf (file = paste0("curvevar",k,".pdf"), width = 10, height = 7)
  }
  
  # LRM
  
  mod <- lm(y ~ x, data = dfranvar)
  summary(mod)
  x11()
  p0 <- ggplot (data = dfranvar, aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point ()
  p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + geom_smooth (method = "lm", formula = y ~ x + I(x^2) + I(x^3), colour = 1, se = FALSE, size = 1.5)
  # p0 <- p0 + geom_smooth (method = "loess", colour = 1, se = FALSE, size = 1.5)
  p0 <- p0 + geom_line (data = dfranvar, aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
  p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
  print (p0)
  
  dev.copy2pdf (file = paste0("lm3var.pdf"), width = 10, height = 7)
  
  tecka <- list()
  ypska <- list()
  for (k in (1:n)) {
    a <- subset (dfranvar, samp == k)
    ind <- order(a$x)
    tecka[[k]] <- a$x[ind]
    ypska[[k]] <- a$y[ind]
  }
  
  res <- FPCA(ypska, tecka, optns = list(dataType = 'Sparse', userBwMu = 5))#, error=FALSE, kernel='epan', verbose=TRUE))
  # plot(res)
  CreatePathPlot(res, subset = 1:10, K = 3, pch = 20, xlab = "total Mh", ylab = "Fe", main = "Fe vs. total Mh")
  # 
  koef <- res$xiEst[,1:3] # koeficienty u prvnich 3 komponent
  iks <- res$workGrid  # sit x, kde jsou komponenty vyhodnoceny
  compon <- res$phi[, 1:3] # hlavni komponenty v x
  odh <- matrix(rep(1, times = n), c(n, 1)) %*% res$mu + koef %*% t(compon) # rekonstrukce
  #  matplot(iks, t(odh), type = "l") 
  
  dfransparse <- data.frame(x = rep(iks, times = n), y = c(t(odh)),samp = factor(rep(1:n, each = length(iks))))
  dfransparse$meanfda <- res$mu
  
  # meanova krivka
  x11()
  p0 <- ggplot (data = dfransparse, aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point (data = dfranvar, aes(x = x, y = y, colour = samp))
  p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line (aes (y = meanfda), colour = 1, size = 1.5)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
  p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
  print (p0)
  
  dev.copy2pdf (file = paste0("meanfdavar.pdf"), width = 10, height = 7)
  
  # vsechny krivky
  x11()
  p0 <- ggplot (data = dfransparse, aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point (data = na.omit(dfranmiss), aes(x = x, y = y, colour = samp))
  #p0 <- p0 + guides (colour = FALSE) 
  #  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line ()
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T, limits = c(1,T))
  p0 <- p0 + scale_y_continuous (limits = c(Ymin - 0.2, Ymax + 0.2))
  print (p0)
  
  dev.copy2pdf (file = paste0("smcurvesmiss.pdf"), width = 10, height = 7)
  
  #_____________________________________  
  

  # Tohle neni tak dobre
  # ------------------------------------
  # FDA s Fourierovou bazi
  
  timerng <- c(1,T)
  
  #### 1. Fourier Basis with T - 1 basis functions
  
  fbasis <- create.fourier.basis (timerng, T - 1)
  
  # Vytvorime "Lfd" objekty, dve moznosti:
  # 1. int2Lfd -- just penalize some derivatives. 
  # curv.Lfd <- int2Lfd (2)
  
  # 2. vec2Lfd -- a (constant) linear combination of derivatives; for technical
  # reasons this also requires the range of the basis. 
  harmLfd <- vec2Lfd (c(0, (2*pi/(T - 2))^2, 0), rangeval = timerng)
  
  
  #   # definujeme vyhlazovaci parametr lambda
  lambda <- 1
  # 
  # # definujeme "fdPar" objekt 
  harm.fdPar = fdPar(fbasis, harmLfd, lambda)
  
  W <- data.frame(NULL)
  
  # Jak vybrat lambda?
  # cyklus WHILE
  lambdas <- 1
  mean.gcv2 <- mean.gcv1 <- 10^8
  # pokud je v dalsim kroku gcv vetsi, skonci se
  while (mean.gcv1 >= mean.gcv2){
    mean.gcv1 <- mean.gcv2
    lambdas <- lambdas * 10^(1/2)
    # nastavime lambda
    harm.fdPari <- harm.fdPar
    harm.fdPari$lambda <- lambdas
    
    # hladime
    tempSmoothi <- smooth.basis(x, t(y), harm.fdPari)
    
    # ulozime prumerne GCV
    mean.gcv2 <- mean(tempSmoothi$gcv)
  }
  
  # Vybereme nejlepsi a podle neho nadefinujeme hladkou bazi
  lambdabest <- lambdas * 10^(-1/2)
  harm.fdPar$lambda <- lambdabest
  # hladime
  tempSmooth <- smooth.basis(x, t(y), harm.fdPar)
  
  # A vykreslime vyslednou bazi
  xx <- x
  fdobjSmooth <- tempSmooth$fd
  fdobjSmooth_der1 <- deriv.fd(tempSmooth$fd, 1) # 1. derivace
  fdobjSmooth_der2 <- deriv.fd(tempSmooth$fd, 2) # 2. derivace
  fdobjSmootheval <- eval.fd(fdobj = fdobjSmooth, evalarg = xx)
  meanfdobjSmootheval <- eval.fd(fdobj = mean(fdobjSmooth), evalarg = xx)
  fdobjSmootheval_der1 <- eval.fd(fdobj = fdobjSmooth_der1, evalarg = xx)
  fdobjSmootheval_der2 <- eval.fd(fdobj = fdobjSmooth_der2, evalarg = xx)
  # 2 moznosti pro vykresleni, obe stejne
  # par(mfrow=c(2,1))
  # matplot(xx, fdobjSmootheval, type = "l")
  # plot(fdobjSmooth)
  
  df$meanharmfda <- rep(meanfdobjSmootheval, times = n)
  df$fdaharmcurves <- c(fdobjSmootheval)
  
  # meanova krivka
  x11()
  p0 <- ggplot (data = df[1:(10*T), ], aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point ()
  p0 <- p0 + guides (colour = FALSE) 
  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line (aes (y = meanharmfda), colour = 1, size = 1.5)
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = paste0("meanharmfda.pdf"), width = 10, height = 7)
  
  # vsechny krivky
  x11()
  p0 <- ggplot (data = df[1:(10*T), ], aes (x = x, y = y, colour = samp))
  p0 <- p0 + geom_point ()
  #p0 <- p0 + guides (colour = FALSE) 
  #  p0 <- p0 + geom_line (aes (y = sin(0.1*x)), colour = 4, linetype = 2, size = 1.5)
  p0 <- p0 + geom_line (aes (y = fdaharmcurves))
  p0 <- p0 + labs (x = "Time", y = "Observation") 
  p0 <- p0 + scale_colour_discrete(name="Measurement\nOrder")
  p0 <- p0 + theme_bw ()
  p0 <- p0 + scale_x_continuous (breaks = 1:T)
  print (p0)
  
  dev.copy2pdf (file = paste0("smharmcurves.pdf"), width = 10, height = 7)
  
  